Subject: Re: [PATCH v2 net-next 01/12] net: dsa: implement a central TX reallocation procedure

From: Kurt Kanzenbach <[email-masked]>
Date: Fri, 30 Oct 2020 07:41:05 +0100

On Fri Oct 30 2020, Vladimir Oltean wrote:
> At the moment, taggers are left with the task of ensuring that the skb
> headers are writable (which they aren't, if the frames were cloned for
> TX timestamping, for flooding by the bridge, etc), and that there is
> enough space in the skb data area for the DSA tag to be pushed.
>
> Moreover, the life of tail taggers is even harder, because they need to
> ensure that short frames have enough padding, a problem that normal
> taggers don't have.
>
> The principle of the DSA framework is that everything except for the
> most intimate hardware specifics (like in this case, the actual packing
> of the DSA tag bits) should be done inside the core, to avoid having
> code paths that are very rarely tested.
>
> So provide a TX reallocation procedure that should cover the known needs
> of DSA today.
>
> Note that this patch also gives the network stack a good hint about the
> headroom/tailroom it's going to need. Up till now it wasn't doing that.
> So the reallocation procedure should really be there only for the
> exceptional cases, and for cloned packets which need to be unshared.
> The tx_reallocs counter should prove that.
>
> Signed-off-by: Vladimir Oltean <[email-masked]>
> Tested-by: Christian Eggers <[email-masked]> # For tail taggers only

Tested-by: Kurt Kanzenbach <[email-masked]>

I'll wait with the hellcreek series until this is merged.

Thanks,
Kurt